package jcg.zheng.demo.mathoperator.arithmetic;

import static org.junit.Assert.assertEquals;

import org.junit.Test;


public class DecrementOperatorTest {

	@Test
	public void test_decrement_post() {
		int i = 0;
		int j = i--;
		assertEquals(-1, i);
		assertEquals(0, j);

	}

	@Test
	public void test_decrement_pre() {
		int i = 0;
		int j = --i;
		assertEquals(-1, i);
		assertEquals(-1, j);

	}

	@Test
	public void byte_decrement_arithmetic_operator() {
		byte b = 1;
		b--;

		assertEquals(0, b);
	}

	@Test
	public void double_decrement_arithmetic_operator() {
		double d = 10.01;
		d--;

		assertEquals(9.01, d, 2);
	}

	@Test
	public void float_decrement_arithmetic_operator() {
		float f = 10.01f;
		f--;

		assertEquals(9.01, f, 2);
	}

	@Test
	public void int_decrement_arithmetic_operator() {
		int i = 10;
		i--;

		assertEquals(9, i);
	}

	@Test
	public void long_decrement_arithmetic_operator() {
		long l = 10;
		l--;

		assertEquals(9, l);
	}

	@Test
	public void short_decrement_arithmetic_operator() {
		short s = 1;
		s--;

		assertEquals(0, s);
	}

}