package jcg.zheng.demo;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

public class OperatorPrecedenceTest {

	@Test
	public void parentheses_is_first() {
		int result = 100 * 100 / 5 + 200 * 3 / 2 + 6 * (4 % 5);
		assertEquals(2324, result);
	}

	@Test
	public void test_OperatorPrecedence() {
		int result = 100 / 5 * 100 + 200 * 3 / 2 + 6 * 4 % 5;
		assertEquals(2304, result);
	}

	@Test
	public void from_left_to_right() {
		int cal = 1 * 9 % 8 * 3 * 5 / 3;
		assertEquals(5, cal);
	}

	@Test
	public void addion_yields() {
		int cal = 6 + 3 * 5 / 3;
		assertEquals(11, cal);
	}

	@Test
	public void minus_yields() {
		int cal = 6 - 3 * 5 % 3;
		assertEquals(6, cal);
	}

}
