package jcg.zheng.demo.mathoperator.arithmetic;

import static org.junit.Assert.assertEquals;

import org.junit.Test;


public class IncrementOperatorTest {

	@Test
	public void test_increment_post() {
		int i = 0;
		int j = i++;
		assertEquals(1, i);
		assertEquals(0, j);

	}

	@Test
	public void test_increment_pre() {
		int i = 0;
		int j = ++i;
		assertEquals(1, i);
		assertEquals(1, j);

	}

	@Test
	public void byte_increment_arithmetic_operator() {
		byte b = 1;
		b++;

		assertEquals(2, b);
	}

	@Test
	public void double_increment_arithmetic_operator() {
		double d = 10.01;
		d++;

		assertEquals(11.01, d, 2);
	}

	@Test
	public void float_increment_arithmetic_operator() {
		float f = 10.01f;

		f++;

		assertEquals(11.01, f, 2);
	}

	@Test
	public void int_increment_arithmetic_operator() {
		int i = 10;

		i++;
		assertEquals(11, i);
	}

	@Test
	public void long_increment_arithmetic_operator() {
		long l = 10;
		l++;

		assertEquals(11, l);
	}

	@Test
	public void short_increment_arithmetic_operator() {
		short s = 1;
		s++;

		assertEquals(2, s);
	}

}