package jcg.zheng.demo.mathoperator.arithmetic;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

public class SubtractionOperatorTest {

	@Test
	public void byte_subtraction_arithmetic_operator() {
		byte num1 = 3;
		byte num2 = 2;

		byte diff = (byte) (num1 - num2);
		assertEquals(1, diff);
	}

	@Test
	public void byte_subtraction_arithmetic_operator_2() {
		byte num1 = 1;
		byte num2 = 2;

		byte diff = (byte) (num1 - num2);
		assertEquals(-1, diff);
	}

	@Test
	public void double_subtraction_arithmetic_operator() {
		double num1 = 40.09;
		double num2 = 20.05;

		double diff = num1 - num2;
		assertEquals(20.04, diff, 2);
	}

	@Test
	public void double_float() {
		double d = 12.234;
		float f = 10.1f;

		double diff = d - f;
		assertEquals(2.134, diff, 3);
	}

	@Test
	public void double_int() {
		double d = 12.234;
		int i = 10;

		double diff = d - i;
		assertEquals(2.234, diff, 3);
	}

	@Test
	public void float_subtraction_arithmetic_operator() {
		float num1 = 10.08f;
		float num2 = 20.05f;

		float diff = num1 - num2;
		assertEquals(-10.03, diff, 2);
	}

	@Test
	public void float_int() {
		int i = 20;
		float f = 10.1f;

		float diff = i - f;
		assertEquals(9.1f, diff, 1);
	}

	@Test
	public void int_subtraction_arithmetic_operator() {
		int i = 10;
		int i2 = 20;

		int diff = i - i2;
		assertEquals(-10, diff);
	}

	@Test
	public void long_subtraction_arithmetic_operator() {
		long num1 = 10;
		long num2 = 20;

		long diff = num1 - num2;
		assertEquals(-10, diff);
	}

	@Test
	public void long_int() {
		int i = 2;
		long l = 10000l;

		long diff = l - i;
		assertEquals(9998l, diff);
	}

	@Test
	public void short_subtraction_arithmetic_operator() {
		short num1 = 1;
		short num2 = 2;

		short diff = (short) (num1 - num2);
		assertEquals(-1, diff);
	}

	@Test
	public void byte_add_constants() {
		byte diff = 3 - 2;
		assertEquals(1, diff);
	}

	@Test
	public void shorthand() {
		int i = 10;
		i -= 7;

		assertEquals(3, i);
	}

	@Test
	public void test_Integer() {
		Integer num1 = Integer.valueOf(5);
		Integer num2 = Integer.valueOf(6);

		assertEquals(-1, num1 - num2);
	}

}